<template>
	<a-spin :spinning="state.loading" size="large">
        <a-icon slot="indicator" type="loading" spin />
		<div class="row d-flex align-items-center">
			<div class="col-6">
				<h3>
					Новый отдел
				</h3>
			</div>
			<div class="col-6 d-flex justify-content-end">
			    <a-button type="primary" icon="arrow-left" @click="$router.push({ name: 'UsersPage' })">Назад</a-button>
			</div>
			<div v-if="right" class="col-12">
				<form>
					<div class="form-group">
						<label>
							Название отдела <span class="text-danger">*</span>
						</label>
						<a-input placeholder="Введите название отдела" v-model="add.name" />
					</div>
					<div class="form-group">
						<label>
							Описание отдела
						</label>
						<a-textarea placeholder="Введите описание отдела" v-model="add.description" :autosize="{ minRows: 6, maxRows: 12 }" />
					</div>
					<div class="form-group">
						<a-button type="primary" @click="prepareData">Отправить</a-button>
					</div>
				</form>
			</div>
			<div v-else>
				<a-alert message="У вас нет прав на эту операцию" type="error" />
			</div>
		</div>
	</a-spin>
</template>

<script type="text/javascript">
	export default {
		data () {
			return {
				right: false,
				state: {
					loading: false
				},
				add: {
					name: '',
					description: ''
				}
			}
		},
		created () {
			let scopes = JSON.parse(this.$store.state.user.scopes);
			for (var i = scopes.length - 1; i >= 0; i--) {
				if (scopes[i] === '*' || scopes[i] === 'departmentsRight') {
					this.right = true
				}
			}
		},
		methods: {
			prepareData () {
				this.state.loading = true;
				if (this.add.name.length === 0) {
					this.$message.error('Введите название отдела');
					this.state.loading = false;
					return false;
				}

				let data = {
					name: this.add.name,
					description: this.add.description
				}

				this.addDepartment(data);
			},
			addDepartment (data) {
				this.$http.post(this.$store.state.api.url+'addDepartment', data)
				.then(this.addDepartmentSuccess,this.addDepartmentError);
			},
			addDepartmentSuccess (res) {
				this.$message.success('Отдел добавлен!');
				this.$router.push({ name: 'UsersPage' });
			},
			addDepartmentError (err) {
				if (err.status === 500) {
					this.$message.error('Во время выполнения операции произошла ошибка. Обратитесь к администратору!');
				}
				if (err.status === 422) {
					this.$message.error('Такой отдел уже существует!');
				}
				this.state.loading = false;
			}
		}
	} 
</script>